unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const square = 20;
      halfsquare = square div 2;
      square2 = square *2;

var
  Form1: TForm1;
  var BGmap,paintMap : Tbitmap;

implementation

{$R *.DFM}

uses unit2;

const box1Dark  = $800000;
      box1Light = $ffc0c0;
      mapBGcolor = $e0f0ff;
      mapGridcolor = $ffd0c0;

procedure initmaps;forward;
function clip(a,x,b : integer) : integer;forward;

procedure TForm1.FormCreate(Sender: TObject);
//create bitmaps
begin
 BGmap := Tbitmap.create;
 with BGmap do
  begin
   width := paintbox1.width;
   height := paintbox1.height;
   pixelformat := pf32bit;
  end;

 paintMap := Tbitmap.create;
 with paintmap do
  begin
   width := paintbox1.width;
   height := paintbox1.height;
   pixelformat := pf32bit;
  end;

 initMaps;
end;

procedure TForm1.FormDestroy(Sender: TObject);
//free bitmaps
begin
 BGmap.free;
 paintMap.free;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i : byte;
    x1,x2,y1,y2 : word;
begin

// -- draw edge around paintbox1

 with paintbox1 do                //calculate positions
  begin
   x1 := left-2;
   x2 := left+width+1;
   y1 := top-2;
   y2 := top+height+1;
  end;

 with canvas do                   //paint edges on form1
  begin
   pen.Width := 1;
   for i := 0 to 1 do
    begin
     pen.color := box1dark;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.color := box1Light;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;//for i
  end;//with
end;

procedure initmaps;
//initialize bitmaps BGmap & paintmap
var i : word;
begin
 with BGmap do
  with canvas do
   begin
    brush.color := mapBGcolor;           //background
    brush.style := bsSolid;
    fillrect(rect(0,0,width,height));

    i := 0;
    pen.color := mapGridColor;           //horizontal grid
    while i < height do
     begin
      moveto(0,i);
      lineto(width,i);
      inc(i,square);
     end;

    i := 0;
    pen.color := mapGridColor;           //vertical grid
    while i < width do
     begin
      moveto(i,0);
      lineto(i,height);
      inc(i,square);
     end;
   end;//with BGmap

  paintmap.canvas.draw(0,0,BGmap);       //init paintmap
  form1.paintbox1.invalidate;            //refresh paintbox1

end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.canvas.draw(0,0,paintMap);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 p_mouseEvent := meDown;
 mouseX := clip(0,x,paintmap.width);
 mouseY := clip(0,y,paintmap.height);
end;

function clip(a,x,b : integer) : integer;
//adjust x for a<= x < b)
begin
 if x < a then result := a
  else if x >= b then result := b-1
   else result := x;
 drawproc;  
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 p_mouseEvent := meMove;
 mouseX := clip(0,x,paintmap.width);
 mouseY := clip(0,y,paintmap.height);
 drawproc;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 p_mouseEvent := meUp;
 drawproc;
end;

end.
